// **** BEGIN LICENSE BLOCK ****
//   Copyright(c) 2009-2010 MATSUZAWA Jiro
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA
//   02110-1301, USA.  */
// **** END LICENSE BLOCK ****

var rencon;
if (!rencon) {
    rencon = {};
} else if (typeof rencon != "object") {
    throw new Error("cannot use rencon");
}

rencon.BritishLibraryDirectParser = function(){}
rencon.PageParser.cloneParser(rencon.BritishLibraryDirectParser);

rencon.BritishLibraryDirectParser.prototype = {
    pickoutBibRecord : function()
    {
        var recordList;
        var record;
        var title, creator, journal, volume, pubDate, pages, url;
        var recordInfos;
        recordList = this._getRecordList();
        for (var i = 0; i < recordList.length; ++i) {
            title = this._getTitle(recordList[i]);

            recordInfos = this._getRecordInfo(recordList[i]);

            creator = this._getCreator(recordInfos);
            journal = this._getJournal(recordInfos);
            pubDate = this._getPubDate(recordInfos);
            volume = this._getVolume(recordInfos);
            pages = this._getPages(recordInfos);
            url = "";

            record = new rencon.ArticleRecord(title, creator, pubDate, url, journal, volume, pages);
            rencon.bibTable.addRecord(record);
        }
    },


    _getRecordList : function()
    {
        var recordList = null;
        recordList = window._content.document.getElementsByTagName("tbody")[8].
                        getElementsByTagName("tr");
        if (!recordList) {
            throw new Error("no records information");
        }

        return recordList;
    },


    _getTitle : function(item)
    {
        return item.getElementsByTagName("td")[4].getElementsByTagName("a")[0].text;
    },


    _getCreator : function(infos)
    {
        return infos[4];
    },


    _getJournal : function(infos)
    {
        return infos[5];
    },


    _getPubDate : function(infos)
    {
        return infos[6];
    },


    _getVolume : function(infos)
    {
        var vol = infos[7];
        var len = vol.length;
        if (vol.charAt(len-1) == ",") {
            vol = vol.slice(0, len-1);
        }
        return vol;
    },


    _getPages : function(infos)
    {
        var pages = infos[8];
        var prefixPtn = /^page\(s\)\s*/;
        pages = pages.replace(prefixPtn, "");
        return pages;
    },


    _getRecordInfo : function(item)
    {
        var recordInfos = [];
        var lines;
        var lSpaces = /^\s+/;
        var rSpaces = /\s+$/;
        lines = item.getElementsByTagName("td")[4].childNodes[2].data.split("\n");
        for (var i = 0; i < lines.length; ++i) {
            lines[i] = lines[i].replace(lSpaces, "");
            lines[i] = lines[i].replace(rSpaces, "");
            recordInfos.push(lines[i]);
        }
        return recordInfos;
    },


};
